/**
 * 
 */
package cours;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.TreeSet;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author rosmord
 *
 */
public class DictionnaireCompletion extends HttpServlet {

	private TreeSet<String> dictionnaire= new TreeSet<String>();
	
	public void init() throws ServletException {
		try {
			InputStream in = getClass().getResourceAsStream("dictionnaire.txt");
			BufferedReader reader= new BufferedReader(new InputStreamReader(in, "ISO-8859-1"));
			String l;
			while ((l= reader.readLine())!= null) {
				dictionnaire.add(l);
			}
		} catch (IOException e) {
			throw new ServletException(e);
		}
	}
	
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String debut= request.getParameter("debut");
		response.setContentType("text/plain");
		response.setCharacterEncoding("UTF-8");
		PrintWriter w = response.getWriter();
		
		System.out.println("recut "+ debut);
		for (String m: dictionnaire.tailSet(debut)) {
			// Si le mot commence bien par début, l'ajouter.
			// Sinon: terminer la boucle.
			
			if (m.startsWith(debut)) {
				w.print("<option>");
				w.print(protectHTML(m));
				w.print("</option>");
			}
				else
				break;
		}
	}

	/**
	 * Protège tous les caractères spéciaux pour HTML.
	 * @param m
	 * @return
	 */
	private String protectHTML(String m) {
		StringBuffer buff= new StringBuffer();
		for (int i=0; i< m.length(); i++) {
			switch (m.charAt(i)) {
			case '<':
				buff.append("&lt;");
				break;
			case '>':
				buff.append("&gt;");
				break;
			case '&':
				buff.append("&amp;");
				break;
			default:
				buff.append(m.charAt(i));
				break;
			}
		}
		return buff.toString();
	}

	/**
	 * @param debut
	 * @return
	 */
	private ArrayList<String> getMots(String debut) {
		ArrayList<String> mots= new ArrayList<String>();
		return mots;
	}
}
