/**
 * 
 */
package cours;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.TreeSet;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author rosmord
 *
 */
public class DictionnaireCompletionDojo extends HttpServlet {

	private TreeSet<String> dictionnaire= new TreeSet<String>();
	
	/* (non-Javadoc)
	 * @see javax.servlet.GenericServlet#init()
	 */
	@Override
	public void init() throws ServletException {
		try {
			InputStream in = getClass().getResourceAsStream("dictionnaire.txt");
			BufferedReader reader= new BufferedReader(new InputStreamReader(in, "ISO-8859-1"));
			String l;
			while ((l= reader.readLine())!= null) {
				dictionnaire.add(l);
				//System.out.println(l);
			}
		} catch (IOException e) {
			throw new ServletException(e);
		}
	}
	
	/**
	 * Retourne les données sous la forme d'une liste of format JSON :
	 * [['valeur1 à montrer', 'valeur1 de value'], ['valeur2 à montrer', 'valeur2 de value']...]
	 */
	@Override
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String debut= request.getParameter("debut");
		if (debut== null)
			debut= "";
		response.setContentType("text/plain");
		response.setCharacterEncoding("UTF-8");
		PrintWriter w = response.getWriter();
		w.print("[");
		boolean virgule= false;
		int taille= 0;
		for (String m: dictionnaire.tailSet(debut)) {
			// On s'arrête si on a plus de 50 réponses. 
			if (++taille > 50)
				break;
		
			// Si le mot commence bien par début, l'ajouter.
			// Sinon: terminer la boucle.
			if (m.startsWith(debut)) {
				if (virgule)
					w.print(",\n");
				w.print("[\"");
				w.print(protectHTML(m));
				w.print("\",\"");
				w.print(protectHTML(m));
				w.print("\"]");
			}
				else
				break;
			virgule= true;
		}
		w.print("]");
		w.close();
	}

	/**
	 * Protège tous les caractères spéciaux pour HTML.
	 * @param m
	 * @return
	 */
	private String protectHTML(String m) {
		StringBuffer buff= new StringBuffer();
		for (int i=0; i< m.length(); i++) {
			switch (m.charAt(i)) {
			case '<':
				buff.append("&lt;");
				break;
			case '>':
				buff.append("&gt;");
				break;
			case '&':
				buff.append("&amp;");
				break;
			default:
				buff.append(m.charAt(i));
				break;
			}
		}
		return buff.toString();
	}

	/**
	 * @param debut
	 * @return
	 */
	private ArrayList<String> getMots(String debut) {
		ArrayList<String> mots= new ArrayList<String>();
		
		return mots;
		
	}
}
